<html>
	<head>
		<title>Div to Form - http://codeofaninja.com/</title>
		<!--just to include some styles -->
		<link rel="stylesheet" type="text/css" href="css/style.css" />
	</head>
<body>

<div id='banner'>
	<h2>Code of a Ninja Programming Blog</h2>
	<div>Converting a div to an editable HTML form and save changes to database</div>
</div>

<?php
/*
//just getting the id of the user to be edited
$id = $_REQUEST['id'];

//connect to database
include 'libs/db_connect.php';

try {

	//prepare query
	$query = "select id, firstname, lastname, gender from users where id = ? limit 0,1";
	$stmt = $con->prepare( $query );
	
	//this is the first question mark on the query above
	$stmt->bindParam(1, $id);
	
	//execute our query
	$stmt->execute();
	
	//store retrieved row to $row variable
	$row = $stmt->fetch(PDO::FETCH_ASSOC);
	
	//values to fill up our form
	$firstname = $row['firstname'];
	$lastname = $row['lastname'];
	$gender = $row['gender'];
	
}catch(PDOException $exception){ //to handle error
	echo "Error: " . $exception->getMessage();
}
*/
$firstname = "Mike";
$lastname = "Dalisay";
$gender = "Male";
	
?>
<!--start of our form -->
<form id='user_form'>

<!--id field is hidden, this is used to identify what row is to be edited-->
<input type='hidden' value='<?php echo $id; ?>' name='id'/>

<!--
	-just a form made with divs
	-when this div was clicked, it will be a form
-->
<div id='form_div'>
	
	<div class='field'>
		<div class='field_lbl'>Firstname:</div> <!--field name divs -->
		<div class='field_val'>
			<div class='field_div'>
				<!--
					-this shown on page load
					-and is hidden when the form_div was clicked
					-and will be shown again when the user clicked anywhere outside the form_div or cancel button
				-->
				<div id='firstname_text'><?php echo $firstname; ?></div>
			</div>
			<div class='field_input'>
				<!--
					-this is hidden on page load
					-and is shown when form_div was clicked
					-and will be hidden again when the user clicked anywhere outside the form_div or cancel button
				-->
				<input type='text' value='<?php echo $firstname; ?>' name='firstname' id='firstname'/>
			</div>
			<div class='clear_fix'></div>
		</div>
		<div class='clear_fix'></div>
	</div>
	<div class='clear_fix'></div>
	
	<!--same explanation above are given to these next fields-->
	<div class='field'>
		<div class='field_lbl'>Lastname:</div>
		<div class='field_val'>
			<div class='field_div'>
				<div id='lastname_text'><?php echo $lastname; ?></div>
			</div>
			<div class='field_input'><input type='text' value='<?php echo $lastname; ?>' name='lastname' id='lastname' /></div>
			<div class='clear_fix'></div>
		</div>
		<div class='clear_fix'></div>
	</div>
	<div class='clear_fix'></div>
	
	<div class='field'>
		<div class='field_lbl'>Gender:</div>
		<div class='field_val'>
			<div class='field_div'>
				<div id='gender_text'><?php echo $gender; ?></div>
			</div>
			<div class='field_input'>
				<select name='gender' id='gender'>
					<option <?php if($gender == "Male") echo "selected";  ?> >Male</option>
					<option <?php if($gender == "Female") echo "selected";  ?>>Female</option>
				</select>
			</div>
			<div class='clear_fix'></div>
		</div>
		<div class='clear_fix'></div>
	</div>
	<div class='clear_fix'></div>
	
	<!--
	-these buttons are hidden on page load
	-they are shown when form_div was clicked
	-and will be hidden again when the user clicked anywhere outside the form_div or cancel button
	--->
	<div class='btns'>
		<input type='button' value='Save' id='save_btn' />
		<input type='button' value='Cancel' id='cancel_btn' />
	</div>
	
</div>

</form>

<script src="js/jquery.min.js "></script>
<script type='text/javascript'>
$( document ).ready( function(){

	enable_hover(); //hover effect is enabled on page load

	$('#form_div').click(function(){
		edit_mode();
	});
	
	//when clicked the cancel button
	$('body').on('click', '#cancel_btn', function(){
		normal_mode(); //back to normal mode
	});
	
	//we used the jquery delegate func for live events
	$('body').on('click', '#save_btn', function(){
		
		//save first here
		//get the current values
		var fn = $('#firstname').val();
		var ln = $('#lastname').val();
		var gender = $('#gender').val();
		
		//the make it appear in the UI
		$('#firstname_text').text(fn);
		$('#lastname_text').text(ln);
		$('#gender_text').text(gender);
		
		//save the actual data
		//we use jquery serialize to serialize the form and easily get the form values
		//this is how to submit or post form without page refresh
		$.post("save.php", 
			$("#user_form").serialize(),
			function(data) {
				//you can do any event you want here
				alert(data); //alert that the date were saved
				normal_mode(); //back to normal mode
			});
			
	});
	
	//this way we can detect if the user clicked outside the form_div area
	$("body").click(function(e) {
        if (e.target.id == "form_div" || $(e.target).parents("#form_div").size()) { 
            //if clicked inside form_div area,
			//do nothing
        } else {
			//if the user clicked outside the form_div area, 
			//we'll be in normal mode
			normal_mode();
        }
    });
	

	
});

function edit_mode(){

	$('#form_div').css({ 'background-color' : '#fff' }); //just make a white background
	$('#form_div').unbind('hover'); //disable hover
	
	$('.field_div').hide(); //hide the text
	$('.field_input').show(); //show the form element
	$('.btns').show(); //show the buttons

}

//the normal state is the appearance of the page/element when it was first loaded
function normal_mode(){
	enable_hover(); //enable the hover effect again
	$('.field_div').show(); //show the texts
	$('.field_input').hide(); //hide the input elements
	$('.btns').hide(); //hide the buttons
}

//hover effect is used when NOT in 'edit form' mode
//we unbind this effect when we are in the 'edit form' mode
function enable_hover(){
	$('#form_div').hover(
		function(){ //when we hover form_div, bg will be gray with a bit of rounded corners
			$(this).css({
					'background-color' : '#dcdcdc',
					'-moz-border-radius' : '5px',
					'border-radius' : '5px'
					});
		},
		function(){ //when mouse is not hovered, bg will be transparent
			$(this).css({'background-color' : 'transparent'});
		}
	);
}
</script>

</body>
</html>